#include <bits/stdc++.h>
using namespace std;

#define fwd(i, a, n) for (int i = (a); i < (n); i ++)
#define rep(i, n) fwd(i, 0, n)
#define all(X) begin(X), end(X)
#define sz(X) ((int)X.size())
#define st first
#define nd second
#define pii pair<int, int>
#define vi vector<int>
#define ll long long

#ifdef LOC
auto &operator<<(auto &out, pair<auto, auto> a) {
    return out << "(" << a.st << ", " << a.nd << ")";
}

auto &operator<<(auto &out, auto a) {
    out << "{";
    for (auto b : a)
        out << b << ", ";
    return out << "}";
}

void dump(auto... x) { ((cerr << x << ", "), ...) << '\n'; }
#define debug(x...) cerr << "[" #x "]: ", dump(x)
#else
#define debug(...) 0
#endif

const int maxN = 200 * 1000 + 10;

int n, k;
ll h[maxN];

struct fraq {
    ll num, denom;
    int a, b;
};

fraq costfor(int a) {
    fraq f;
    f.num = 0;
    f.denom = k - a;
    f.a = a;
    f.b = k - a;
    rep(i, n)
        f.num += (h[i] + a - 1) / a;
    return f;
}

bool operator<(fraq a, fraq b) {
    return __int128_t(a.num) * b.denom < __int128_t(b.num) * a.denom;
}

const int magic = 1500;

int32_t main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    cin >> n >> k;
    rep(i, n)
        cin >> h[i];
    sort(h, h + n);

    fraq best = costfor(1);
    /*rep(i, min(n, magic)) {
        if (h[i] < k)
            best = min(best, costfor(h[i]));
        if (h[n - 1 - i] < k)
            best = min(best, costfor(h[n - 1 - i]));
    }*/
    for (int i = 2; i < min(magic, k); i ++)
        best = min(best, costfor(i));
    for (int i = max(1, k - magic); i < k; i ++)
        best = min(best, costfor(i));
    int pol = k / 2;
    for (int i = max(1, pol - magic); i < min(k, pol + magic); i ++)
        best = min(best, costfor(i));
    cout << best.a << ' ' << best.b << '\n';
    return 0;
}