#include <bits/stdc++.h>
using namespace std;

#define fwd(i, a, n) for (int i = (a); i < (n); i ++)
#define rep(i, n) fwd(i, 0, n)
#define all(X) begin(X), end(X)
#define sz(X) ((int)X.size())
#define st first
#define nd second
#define pii pair<int, int>
#define vi vector<int>
#define ll long long

#ifdef LOC
auto &operator<<(auto &out, pair<auto, auto> a) {
    return out << "(" << a.st << ", " << a.nd << ")";
}

auto &operator<<(auto &out, auto a) {
    out << "{";
    for (auto b : a)
        out << b << ", ";
    return out << "}";
}

void dump(auto... x) { ((cerr << x << ", "), ...) << '\n'; }
#define debug(x...) cerr << "[" #x "]: ", dump(x)
#else
#define debug(...) 0
#endif

#define DRIVE 101
#define PICKUP 102
#define DROPOFF 103

int32_t main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n;
    cin >> n;
    string prze, gosc;
    cin >> prze >> gosc;
    vi done(n, 0);
    rep(i, n)
        if (prze[i] == gosc[i])
            done[i] = 1;
    vector<pii> odp;
    while (true) {
        int no_prze = -1;
        rep(i, n)
            if (!done[i] && prze[i] == '-') {
                no_prze = i;
                break;
            }
        if (no_prze == -1)
            break;
        done[no_prze] = 1;
        if (gosc[no_prze] == '-')
            continue;
        char ziomek = gosc[no_prze];
        odp.push_back({DRIVE, no_prze});
        odp.push_back({PICKUP, -1});
        while (true) {
            int nxt = -1;
            char szuk = ziomek ^ 'C' ^ 'M';
            rep(i, n)
                if (!done[i] && prze[i] == ziomek && gosc[i] == szuk) {
                    nxt = i;
                    break;
                }
            if (nxt == -1)
                break;
            done[nxt] = 1;
            odp.push_back({DRIVE, nxt});
            odp.push_back({DROPOFF, -1});
            odp.push_back({PICKUP, -1});
            ziomek = szuk;
        }
        int lol = -1;
        rep(i, n)
            if (!done[i] && prze[i] == ziomek && gosc[i] == '-')
                lol = i;
        if (lol != -1) {
            done[lol] = 1;
            odp.push_back({DRIVE, lol});
            odp.push_back({DROPOFF, -1});
        } else {
            odp.pop_back();
        }
    }
    cout << sz(odp) << '\n';
    for (auto [t, v] : odp) {
        if (t == DRIVE) {
            cout << "DRIVE " << v + 1 << '\n';
        } else if (t == PICKUP) {
            cout << "PICKUP" << '\n';
        } else {
            cout << "DROPOFF" << '\n';
        }
    }
    return 0;
}