#include <bits/stdc++.h>
using namespace std;

#define fwd(i, a, n) for (int i = (a); i < (n); i ++)
#define rep(i, n) fwd(i, 0, n)
#define all(X) begin(X), end(X)
#define sz(X) ((int)X.size())
#define st first
#define nd second
#define pii pair<int, int>
#define vi vector<int>
#define ll long long

#ifdef LOC
auto &operator<<(auto &out, pair<auto, auto> a) {
    return out << "(" << a.st << ", " << a.nd << ")";
}

auto &operator<<(auto &out, auto a) {
    out << "{";
    for (auto b : a)
        out << b << ", ";
    return out << "}";
}

void dump(auto... x) { ((cerr << x << ", "), ...) << '\n'; }
#define debug(x...) cerr << "[" #x "]: ", dump(x)
#else
#define debug(...) 0
#endif

vector<vi> g;
vi ofcol;
vi col;

void dfs(int i, int c) {
    if (col[i] == c)
        return;
    if (col[i] == !c) {
        ofcol[0] = -1e9;
        return;
    }
    col[i] = c;
    ofcol[col[i]]++;
    for (int j : g[i])
        dfs(j, !c);
} 

int32_t main() {
    ios_base::sync_with_stdio(0), cin.tie(0);

    int n;
    cin >> n;

    vector<ll> x(n), y(n), r(n);
    rep(i, n)
        cin >> x[i] >> y[i] >> r[i];

    g.resize(n);

    rep(i, n) rep(j, i) {
        ll distsq = (x[i]-x[j])*(x[i]-x[j]) + (y[i]-y[j])*(y[i]-y[j]);
        ll sumradii = r[i] + r[j];

        if (sumradii * sumradii != distsq)
            continue;
        g[i].push_back(j);
        g[j].push_back(i);
    }

    col.assign(n, -1);

    rep(i, n)
        debug(i, g[i]);

    rep(i, n) if (col[i] == -1) {
        ofcol.assign(2, 0);
        dfs(i, 0);
        debug(i, ofcol);
        if (ofcol[0] >= 0 && ofcol[0] != ofcol[1]) {
            cout << "YES\n";
            return 0;
        }
    }

    cout << "NO\n";
    
    return 0;
}