#include <bits/stdc++.h>
using namespace std;

#define fwd(i, a, n) for (int i = (a); i < (n); i ++)
#define rep(i, n) fwd(i, 0, n)
#define all(X) begin(X), end(X)
#define sz(X) ((int)X.size())
#define st first
#define nd second
#define pii pair<int, int>
#define vi vector<int>
#define ll long long

#ifdef LOC
auto &operator<<(auto &out, pair<auto, auto> a) {
    return out << "(" << a.st << ", " << a.nd << ")";
}

auto &operator<<(auto &out, auto a) {
    out << "{";
    for (auto b : a)
        out << b << ", ";
    return out << "}";
}

void dump(auto... x) { ((cerr << x << ", "), ...) << '\n'; }
#define debug(x...) cerr << "[" #x "]: ", dump(x)
#else
#define debug(...) 0
#endif

void solve(){
    int n; cin>>n;
    vector<int> a(n);
    vector<int> b(n);
    rep(i, n)cin>>a[i];
    rep(i, n)cin>>b[i];
    sort(all(a));
    sort(all(b));
    int res = 1e9;
    rep(i, n){
        int c = n-1;
        int d = 0;
        int cnt = 0;
        for(int j = i; j < n; j++){
            while(c >= 0 && abs(a[i] - b[c]) >= res){
                cnt++;
                c--;
            }
            while(d < n && abs(a[j] - b[d]) >= res){
                cnt++;
                d++;
            }
            while(cnt < j - i + 1){
                int x = 0;
                if(c >= 0)x = abs(a[i] - b[c]);
                int y = 0;
                if(d < n)y = abs(a[j] - b[d]);
                res = max(x, y);
                while(c >= 0 && abs(a[i] - b[c]) >= res){
                    cnt++;
                    c--;
                }
                while(d < n && abs(a[j] - b[d]) >= res){
                    cnt++;
                    d++;
                }
            }
        }
    }   
    cout<<res<<"\n";
}

int32_t main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int t; cin>>t;
    while(t--){
        solve();
    }
    return 0;
}