#include <bits/stdc++.h>
using namespace std;

#define fwd(i, a, n) for (int i = (a); i < (n); i ++)
#define rep(i, n) fwd(i, 0, n)
#define all(X) begin(X), end(X)
#define sz(X) ((int)X.size())
#define st first
#define nd second
#define pii pair<int, int>
#define vi vector<int>
#define ll long long

#ifdef LOC
auto &operator<<(auto &out, pair<auto, auto> a) {
    return out << "(" << a.st << ", " << a.nd << ")";
}

auto &operator<<(auto &out, auto a) {
    out << "{";
    for (auto b : a)
        out << b << ", ";
    return out << "}";
}

void dump(auto... x) { ((cerr << x << ", "), ...) << '\n'; }
#define debug(x...) cerr << "[" #x "]: ", dump(x)
#else
#define debug(...) 0
#endif

void solve() {
    int n;
    cin >> n;
    set<int> interesting;
    map<int, vector<pii>> ban;
    rep(_, n) {
        int x, y;
        cin >> x >> y;
        interesting.insert(x+y);
        ban[x+y].emplace_back(x, y);
    }
    if (sz(ban[0]) == 0) {
        cout << "YES\n";
        return;
    }
    set<pii> corners;
    map<int, vector<pii>> rem;
    auto addcorn = [&](int x, int y) {
        corners.emplace(x, y);
        rem[x+y-1].emplace_back(x, y);
    };
    addcorn(1, 1);

    int prv = 0;
    while (true) {
        auto ittt = interesting.upper_bound(prv);
        if (ittt == interesting.end())
            break;
        prv = *ittt;

        set<pii> seen;
        for (auto [x, y] : ban[prv]) {
            auto it = corners.upper_bound(pii{x, 1e9});
            if (it == corners.begin())
                continue;
            --it;
            auto [ci, cj] = *it;
            if (x > ci || y > cj)
                continue;
            if (x == ci) {
                corners.erase(it);
                addcorn(ci + 1, cj);
                continue;
            }
            if (y == cj) {
                corners.erase(it);
                addcorn(ci, cj + 1);
                continue;
            }
        }

        for (auto [x, y] : rem[prv]) {
            corners.erase({x, y});
        }
    }

    cout << "YES\n";
}

int32_t main() {
    ios_base::sync_with_stdio(0), cin.tie(0);

    int z;
    cin >> z;
    while (z--)
        solve();
    
    return 0;
}